#include "Program.h"
#include "Arduino.h"
#include "DolibarrClient.h"

int initialize_wifi(WifiConfig wifi) {
    WiFiClass::mode(WIFI_STA); //Optional
    WiFi.setSleep(false);
    WiFi.begin(wifi.ssid, wifi.password);
    Serial.print("Connecting ");
    while(WiFiClass::status() != WL_CONNECTED){
        delay(WAITING_WIFI_DELAY);
        Serial.print(".");
    }
    Serial.println("Connected to the WiFi network");
    return 0;
}

Program::Program() {
    Serial.begin(MONITOR_SPEED);
    struct WifiConfig wifi_c = {WIFI_SSID, WIFI_PASSWORD};
    struct DolibarrConfig dolibarr = {DOLIBARR_URL, DOLIBARR_API_TOKEN};
    initialize_wifi(wifi_c);
    this->client = new DolibarrClient(dolibarr);

    // initialisation GRBL
    this->grbl = new GRBL(STEPMOTOR_I2C_ADDR);
    Wire.begin(21, 22);
    grbl->init(STEPER_SPEED, STEPER_PAS, STEPER_ACC);

    this->NFC = new NfcReader(NFC_ADDR);
}

void Program::loop() {
    // if(this->grbl->)
    // this->grbl->mouveForward(5); //TODO: réglé pour qu'il avance de la bonne distance
    // String nfcIn = "0"; // TODO: si le lecteur envoie qqc
    // //TODO: refrech servo
    // if(nfcIn !="0"){
    //     //envoyer sur dolibard
    //     this->NfcIDs->push_back(nfcIn);
    // }
    // if(this->NfcIDs->size() > 0){
    // }

    //algo V1
    //je lis la valeur NFC
    String nfcId = this->NFC->ReadNfc();
    //si qqc
    if(nfcId != "0"){
        //j'arrète le stepper
        //this->grbl->stop(); //FIXME: implemente
        //j'affiche le tag lue
        Serial.print("new colis in comming : ");
        Serial.println(nfcId);
        //je demande a dolibard ou j'envoie
        Serial.println("Demande a dolibard");
        delay(500);// TODO: remove mock
        //j'envoie au servo la commande
        Serial.print("Servo : ");
        Serial.println("Droite");
        delay(500);// TODO: remove mock
        //j'avance le moteur jusqu'a X (a definir)
        this->grbl->mouveForward(CONVOYER_LEN);
    }else{
        //si rien
        //je check si le stepper est en iddle
        if(this->grbl->isIddle()){
            //si oui j'avance de 5 mm
            this->grbl->mouveForward(5);
        }
    }
    //j'update la position du servo

    //idée algo v1.5 (ajou petite gestion d'erreur)
    //je lis la valeur NFC
    //si qqc
        //je demande a dolibard ou j'envoie
        //j'envoie au servo la commande
        //j'avance le moteur jusqu'a X (a definir)
    //si rien j'avance le moteur (5mm)
    //si le lecteur de sortie voi pas de colis
        //on affiche une erreur de colis non lue
    //si un seul colis
        //on dit que le colis est bien trié (avec porte de sortie)
    //si il y a 2 colis (ou plus)
        //on affiche une erreur de bourrage

    //idée algo v2
    //utiliser une pile
    //utiliser le 2nd lecteur pour vidé la pile
    //gestion d'erreur complete avec celle du dessus plus celle de la pile

}


